#add arcpy model
import arcpy
import arcgisscripting
arcpy.CheckOutExtension("Spatial")
from arcpy.sa import *
from arcpy import env
gp = arcgisscripting.create(10.5)

# OverwriteOutput
gp.OverwriteOutput = 1
# INPUT
PLOTCHM = arcpy.GetParameterAsText(0)
POINT= arcpy.GetParameterAsText(1)
RADIUS = arcpy.GetParameterAsText(2)
PLOT = arcpy.GetParameterAsText(3)
TABLE = arcpy.GetParameterAsText(4)

# GET RES
RES = arcpy.GetRasterProperties_management(PLOTCHM, "CELLSIZEX")
RESOLUTION = RES.getOutput(0)

#WORKPLACE
tempfiles = "E:\\CanopyClosure\\TEST.gdb"
gp.workspace = tempfiles
gp.scratchworkspace = tempfiles
work = tempfiles

# GET BUFFER
BUFFER = work + "/BUFFER"
arcpy.Buffer_analysis(POINT, BUFFER, RADIUS)

# EXTRACT BY MASK
EXTRACT_CHM = work + "/EXTRACT_CHM"
EXTRACT_CHM = ExtractByMask(PLOTCHM,BUFFER)

# THREHOLD 2M
CLASSIFY = work + "/CLASSIFY"
CLASSIFY = (EXTRACT_CHM > 2)

# COPYROWS
COPYROWS = work + "/COPYROWS"
arcpy.CopyRows_management(CLASSIFY, COPYROWS,"")

# ADD FIELD & FIELD CALCULATE
arcpy.AddField_management(COPYROWS, "NAME", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.AddField_management(COPYROWS, "RESOLUTION", "FLOAT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")

arcpy.CalculateField_management(COPYROWS, "NAME", PLOT, "VB", "")
arcpy.CalculateField_management(COPYROWS, "RESOLUTION", RESOLUTION, "VB", "")

# PIVOT TABLE
arcpy.PivotTable_management(COPYROWS, "NAME;RESOLUTION", "Value", "Count", TABLE)

# CALCUTATE CC
arcpy.AddField_management(TABLE, "CanopyClosure", "FLOAT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.CalculateField_management(TABLE, "CanopyClosure", "!Value1! /( !Value0! + !Value1! )", "PYTHON_9.3", "")













