#arcpyģ
import arcpy
import arcgisscripting
arcpy.CheckOutExtension("Spatial")
from arcpy.sa import *
from arcpy import env
gp = arcgisscripting.create(10.5)

#
gp.OverwriteOutput = 1 
#ͼ
inRaster = arcpy.GetParameterAsText(0)  #raster layer
RED =arcpy.sa.Raster(inRaster+'/Band_1')
GREEN = arcpy.sa.Raster(inRaster+'/Band_2')
BLUE =arcpy.sa.Raster(inRaster+'/Band_3')
#һʱļ
tempfiles = arcpy.GetParameterAsText(1)
if tempfiles == '#' or not tempfiles:
    tempfiles = "D:\\\״ն\\ļ\\test.gdb" 
gp.workspace = tempfiles
gp.scratchworkspace = tempfiles

work = tempfiles

#
leaf = work + "/leaf"
trunk = work + "/trunk"
sky = work + "/sky"

#Ҫͼ
leaf_out = arcpy.GetParameterAsText(2)
trunk_out = arcpy.GetParameterAsText(3)
sky_out = arcpy.GetParameterAsText(4)
#㣺R>=G&R>=B&G<200
mixtrunk1 = work + "/mixtrunk1"
mixtrunk1 = (RED >= GREEN )&(RED >= BLUE )&(RED < 200)
#MAJORITY 7*7
FocalSt_MAJ77 = work + "/FocalSt_MAJ77"
FocalSt_MAJ77 = FocalStatistics(mixtrunk1,  "Rectangle 7 7 CELL", "MAJORITY", "DATA")
#SET NULL 
mixtrunk2 =  work + "/mixtrunk2"
mixtrunk2 = SetNull(FocalSt_MAJ77, GREEN, "VALUE = 0")
# R>= G & R >=B again
mixtrunk3 = work + "/mixtrunk3"
mixtrunk3 = Con(mixtrunk2, (RED >= GREEN )&(RED >= BLUE ))
# RECLASSIFY TO TWOVALUE
#mixtrunk4 = work + "/mixtrunk4"   

# MINIMUM 5*5
FocalSt_MIN55 =  work + "/FocalSt_MIN55"
FocalSt_MIN55 = FocalStatistics(mixtrunk3,  "Rectangle 5 5 CELL", "MINIMUM", "NODATA")
# MINIMUM 3*3
FocalSt_MIN33 =  work + "/FocalSt_MIN33"
FocalSt_MIN33 = FocalStatistics(FocalSt_MIN55,  "Rectangle 3 3 CELL", "MINIMUM", "NODATA")
# MAXIMUM 5*5
FocalSt_MAX55 = work + "/FocalSt_MAX55"
FocalSt_MAX55 = FocalStatistics(FocalSt_MIN33,  "Rectangle 5 5 CELL", "MAXIMUM", "DATA")
# MAXIMUM 3*3 
FocalSt_MAX33 = work + "/FocalSt_MAX33"
FocalSt_MAX33 = FocalStatistics(FocalSt_MAX55,  "Rectangle 3 3 CELL", "MAXIMUM", "DATA")

# SET NULL 
mixtrunk4 = work + "/mixtrunk4"
mixtrunk4 = SetNull(FocalSt_MAX33, FocalSt_MAX33, "VALUE = 0")
# REGION GROUP
REGION = work + "/REGION"
REGION = RegionGroup(mixtrunk4,  "FOUR", "WITHIN", "ADD_LINK", "")
# SET NULL
SETNULL_REGION = work + "/SETNULL_REGION"
SETNULL_REGION = SetNull(REGION, REGION, "COUNT < 100")

# RASTER CALCUTATOR TO GET TRUNK

trunk  = (SETNULL_REGION >0)

#SET NULL TO GET TRUNK
#trunk_out =  SetNull(TWOVALUE, TWOVALUE, "VALUE = 0") 

# RECLASSIFY TO DEFINE 1-VALUE
notrunk1 =  work + "/notrunk1"
notrunk1 = Reclassify(trunk, "Value", "0 0;1 1;NODATA 0", "DATA")

# SET NULL TO EXTRACT 0-255NOTRUNK PIXEL
notrunk2 =  work + "/notrunk2"
notrunk2 = SetNull(notrunk1, GREEN, "VALUE = 1")

# THREHOLD < 200
notrunk3 =  work + "/notrunk3"
notrunk3 = (notrunk2 < 200)

# SET NULL TO GET LEAF & SKY 
leaf = SetNull(notrunk3, notrunk3, "VALUE = 0")
sky = SetNull(notrunk3, notrunk3, "VALUE = 1")

#save
sky.save("sky")
leaf.save("leaf")
trunk.save("trunk")

# copy raster 
arcpy.Copy_management(leaf,leaf_out)
arcpy.Copy_management(trunk,trunk_out)
arcpy.Copy_management(sky,sky_out)

##TABLE DEAL
#COPY ROWS
TRUNK_CopyRows = work + "/TRUNK_CopyRows"
LEAF_CopyRows = work + "/LEAF_CopyRows"
SKY_CopyRows = work + "/SKY_CopyRows"
arcpy.CopyRows_management(trunk, TRUNK_CopyRows, "")
arcpy.CopyRows_management(leaf, LEAF_CopyRows, "")
arcpy.CopyRows_management(sky, SKY_CopyRows, "")
#ADD CLASS FIELD
arcpy.AddField_management(TRUNK_CopyRows, "CLASS", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.AddField_management(LEAF_CopyRows, "CLASS", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.AddField_management(SKY_CopyRows, "CLASS", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
#Calculate Field
arcpy.CalculateField_management(TRUNK_CopyRows, "CLASS", "\"trunk\"", "VB", "")
arcpy.CalculateField_management(LEAF_CopyRows, "CLASS", "\"leaf\"", "VB", "")
arcpy.CalculateField_management(SKY_CopyRows, "CLASS", "\"sky\"", "VB", "")

#ADD PLOT FIELD
arcpy.AddField_management(TRUNK_CopyRows, "PLOT", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.AddField_management(LEAF_CopyRows, "PLOT", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
arcpy.AddField_management(SKY_CopyRows, "PLOT", "TEXT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
#Calculate Field
Expression = arcpy.GetParameterAsText(5)
arcpy.CalculateField_management(TRUNK_CopyRows, "PLOT", Expression, "VB", "")
arcpy.CalculateField_management(LEAF_CopyRows, "PLOT", Expression, "VB", "")
arcpy.CalculateField_management(SKY_CopyRows, "PLOT", Expression, "VB", "")

#MERGE
CopyRows_Merge = work + "/CopyRows_Merge" 
arcpy.Merge_management([TRUNK_CopyRows,LEAF_CopyRows,SKY_CopyRows], CopyRows_Merge)

#նԶı
tableall = arcpy.GetParameterAsText(6) 
# Pivot Table
arcpy.PivotTable_management(CopyRows_Merge, "PLOT", "CLASS", "Count", tableall )
#ADD CANOPYCLOSURE FIELD
arcpy.AddField_management(tableall, "CanopyClosure", "FLOAT", "", "", "", "", "NULLABLE", "NON_REQUIRED", "")
#Calculate Field
arcpy.CalculateField_management(tableall, "CanopyClosure", "!leaf!/( !leaf!+ !sky!+ !trunk!)", "PYTHON_9.3", "")





